#

API Docs for: 1.6.0
Show: Inherited Protected Private Deprecated

# File: src/pixi/textures/RenderTexture.js

    /**
     * @author Mat Groves http://matgroves.com/ @Doormat23
     */

    /**
     A RenderTexture is a special texture that allows any pixi displayObject to be rendered to it.

     __Hint__: All DisplayObjects (exmpl. Sprites) that render on RenderTexture should be preloaded.
     Otherwise black rectangles will be drawn instead.

     RenderTexture takes snapshot of DisplayObject passed to render method. If DisplayObject is passed to render method, position and rotation of it will be ignored. For example:

        var renderTexture = new PIXI.RenderTexture(800, 600);
        var sprite = PIXI.Sprite.fromImage("spinObj_01.png");
        sprite.position.x = 800/2;
        sprite.position.y = 600/2;
        sprite.anchor.x = 0.5;
        sprite.anchor.y = 0.5;
        renderTexture.render(sprite);

     Sprite in this case will be rendered to 0,0 position. To render this sprite at center DisplayObjectContainer should be used:

        var doc = new PIXI.DisplayObjectContainer();
        doc.addChild(sprite);
        renderTexture.render(doc);  // Renders to center of renderTexture

     * @class RenderTexture
     * @extends Texture
     * @constructor
     * @param width {Number} The width of the render texture
     * @param height {Number} The height of the render texture
     * @param scaleMode {Number} Should be one of the PIXI.scaleMode consts
     */
    PIXI.RenderTexture = function(width, height, renderer, scaleMode)
    {
        PIXI.EventTarget.call( this );

        /**
         * The with of the render texture
         *
         * @property width
         * @type Number
         */
        this.width = width || 100;
        /**
         * The height of the render texture
         *
         * @property height
         * @type Number
         */
        this.height = height || 100;

        /**
         * The framing rectangle of the render texture
         *
         * @property frame
         * @type Rectangle
         */
        this.frame = new PIXI.Rectangle(0, 0, this.width, this.height);

        /**
         * This is the area of the BaseTexture image to actually copy to the Canvas / WebGL when rendering,
         * irrespective of the actual frame size or placement (which can be influenced by trimmed texture atlases)
         *
         * @property crop
         * @type Rectangle
         */
        this.crop = new PIXI.Rectangle(0, 0, 1, 1);

        /**
         * The base texture object that this texture uses
         *
         * @property baseTexture
         * @type BaseTexture
         */
        this.baseTexture = new PIXI.BaseTexture();
        this.baseTexture.width = this.width;
        this.baseTexture.height = this.height;
        this.baseTexture._glTextures = [];

        this.baseTexture.scaleMode = scaleMode || PIXI.scaleModes.DEFAULT;

        this.baseTexture.hasLoaded = true;

        // each render texture can only belong to one renderer at the moment if its webGL
        this.renderer = renderer || PIXI.defaultRenderer;

        if(this.renderer.type === PIXI.WEBGL_RENDERER)
        {
            var gl = this.renderer.gl;

            this.textureBuffer = new PIXI.FilterTexture(gl, this.width, this.height, this.baseTexture.scaleMode);
            this.baseTexture._glTextures[gl.id] =  this.textureBuffer.texture;

            this.render = this.renderWebGL;
            this.projection = new PIXI.Point(this.width/2 , -this.height/2);
        }
        else
        {
            this.render = this.renderCanvas;
            this.textureBuffer = new PIXI.CanvasBuffer(this.width, this.height);
            this.baseTexture.source = this.textureBuffer.canvas;
        }

        PIXI.Texture.frameUpdates.push(this);

    };

    PIXI.RenderTexture.prototype = Object.create(PIXI.Texture.prototype);
    PIXI.RenderTexture.prototype.constructor = PIXI.RenderTexture;

    /**
     * Resize the RenderTexture.
     *
     * @method resize
     * @param width {Number} The width to resize to.
     * @param height {Number} The height to resize to.
     * @param updateBase {Boolean} Should the baseTexture.width and height values be resized as well?
     */
    PIXI.RenderTexture.prototype.resize = function(width, height, updateBase)
    {
        if (width === this.width && height === this.height)
        {
            return;
        }

        this.width = width;
        this.height = height;

        this.frame.width = this.width;
        this.frame.height = this.height;

        if (updateBase)
        {
            this.baseTexture.width = this.width;
            this.baseTexture.height = this.height;
        }

        if (this.renderer.type === PIXI.WEBGL_RENDERER)
        {
            this.projection.x = this.width / 2;
            this.projection.y = -this.height / 2;
        }

        this.textureBuffer.resize(this.width, this.height);
    };

    /**
     * Clears the RenderTexture.
     *
     * @method clear
     */
    PIXI.RenderTexture.prototype.clear = function()
    {
        if (this.renderer.type === PIXI.WEBGL_RENDERER)
        {
            this.renderer.gl.bindFramebuffer(this.renderer.gl.FRAMEBUFFER, this.textureBuffer.frameBuffer);
        }

        this.textureBuffer.clear();
    };

    /**
     * This function will draw the display object to the texture.
     *
     * @method renderWebGL
     * @param displayObject {DisplayObject} The display object to render this texture on
     * @param clear {Boolean} If true the texture will be cleared before the displayObject is drawn
     * @private
     */
    PIXI.RenderTexture.prototype.renderWebGL = function(displayObject, position, clear)
    {
        //TOOD replace position with matrix..
        var gl = this.renderer.gl;

        gl.colorMask(true, true, true, true);

        gl.viewport(0, 0, this.width, this.height);

        gl.bindFramebuffer(gl.FRAMEBUFFER, this.textureBuffer.frameBuffer );

        if(clear)this.textureBuffer.clear();

        // THIS WILL MESS WITH HIT TESTING!
        var children = displayObject.children;

        //TODO -? create a new one??? dont think so!
        var originalWorldTransform = displayObject.worldTransform;
        displayObject.worldTransform = PIXI.RenderTexture.tempMatrix;
        // modify to flip...
        displayObject.worldTransform.d = -1;
        displayObject.worldTransform.ty = this.projection.y * -2;

        if(position)
        {
            displayObject.worldTransform.tx = position.x;
            displayObject.worldTransform.ty -= position.y;
        }

        for(var i=0,j=children.length; i<j; i++)
        {
            children[i].updateTransform();
        }

        // update the textures!
        PIXI.WebGLRenderer.updateTextures();

        this.renderer.spriteBatch.dirty = true;

        this.renderer.renderDisplayObject(displayObject, this.projection, this.textureBuffer.frameBuffer);

        displayObject.worldTransform = originalWorldTransform;

        this.renderer.spriteBatch.dirty = true;
    };

    /**
     * This function will draw the display object to the texture.
     *
     * @method renderCanvas
     * @param displayObject {DisplayObject} The display object to render this texture on
     * @param clear {Boolean} If true the texture will be cleared before the displayObject is drawn
     * @private
     */
    PIXI.RenderTexture.prototype.renderCanvas = function(displayObject, position, clear)
    {
        var children = displayObject.children;

        var originalWorldTransform = displayObject.worldTransform;

        displayObject.worldTransform = PIXI.RenderTexture.tempMatrix;

        if(position)
        {
            displayObject.worldTransform.tx = position.x;
            displayObject.worldTransform.ty = position.y;
        }
        else
        {
            displayObject.worldTransform.tx = 0;
            displayObject.worldTransform.ty = 0;
        }

        for(var i = 0, j = children.length; i < j; i++)
        {
            children[i].updateTransform();
        }

        if(clear)this.textureBuffer.clear();

        var context = this.textureBuffer.context;

        this.renderer.renderDisplayObject(displayObject, context);

        context.setTransform(1,0,0,1,0,0);

        displayObject.worldTransform = originalWorldTransform;
    };

    PIXI.RenderTexture.tempMatrix = new PIXI.Matrix();